// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IdDNSServer.pas' rev: 6.00

#ifndef IdDNSServerHPP
#define IdDNSServerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <IdObjs.hpp>	// Pascal unit
#include <IdDNSCommon.hpp>	// Pascal unit
#include <IdThread.hpp>	// Pascal unit
#include <IdStackConsts.hpp>	// Pascal unit
#include <IdCustomTCPServer.hpp>	// Pascal unit
#include <IdUDPServer.hpp>	// Pascal unit
#include <IdDNSResolver.hpp>	// Pascal unit
#include <IdExceptionCore.hpp>	// Pascal unit
#include <IdResourceStrings.hpp>	// Pascal unit
#include <IdUDPBase.hpp>	// Pascal unit
#include <IdContext.hpp>	// Pascal unit
#include <IdComponent.hpp>	// Pascal unit
#include <IdBaseComponent.hpp>	// Pascal unit
#include <IdGlobalProtocols.hpp>	// Pascal unit
#include <IdGlobal.hpp>	// Pascal unit
#include <IdIOHandlerSocket.hpp>	// Pascal unit
#include <IdSocketHandle.hpp>	// Pascal unit
#include <IdAssignedNumbers.hpp>	// Pascal unit
#include <IdContainers.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Iddnsserver
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TIdDomainExpireCheckThread;
class PASCALIMPLEMENTATION TIdDomainExpireCheckThread : public Idthread::TIdThread 
{
	typedef Idthread::TIdThread inherited;
	
protected:
	unsigned FInterval;
	System::TObject* FSender;
	Classes::TNotifyEvent FTimerEvent;
	bool FBusy;
	AnsiString FDomain;
	AnsiString FHost;
	virtual void __fastcall Run(void);
	void __fastcall TimerEvent(void);
public:
	#pragma option push -w-inl
	/* TIdThread.Create */ inline __fastcall virtual TIdDomainExpireCheckThread(bool ACreateSuspended, bool ALoop, AnsiString AName) : Idthread::TIdThread(ACreateSuspended, ALoop, AName) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TIdThread.Destroy */ inline __fastcall virtual ~TIdDomainExpireCheckThread(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIdDomainNameServerMapping;
class DELPHICLASS TIdDNSMap;
class DELPHICLASS TIdDNS_UDPServer;
class DELPHICLASS TIdDNTreeNode;
class DELPHICLASS TIdMWayTreeNode;
typedef TMetaClass*TIdMWayTreeNodeClass;

class PASCALIMPLEMENTATION TIdMWayTreeNode : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Idcontainers::TIdObjectList* SubTree;
	TMetaClass*FFundmentalClass;
	TIdMWayTreeNode* __fastcall GetTreeNode(int Index);
	void __fastcall SetFundmentalClass(const TMetaClass* Value);
	void __fastcall SetTreeNode(int Index, const TIdMWayTreeNode* Value);
	
public:
	__fastcall virtual TIdMWayTreeNode(TMetaClass* NodeClass);
	__fastcall virtual ~TIdMWayTreeNode(void);
	__property TMetaClass* FundmentalClass = {read=FFundmentalClass, write=SetFundmentalClass};
	__property TIdMWayTreeNode* Children[int Index] = {read=GetTreeNode, write=SetTreeNode};
	TIdMWayTreeNode* __fastcall AddChild(void);
	TIdMWayTreeNode* __fastcall InsertChild(int Index);
	void __fastcall RemoveChild(int Index);
};


class PASCALIMPLEMENTATION TIdDNTreeNode : public TIdMWayTreeNode 
{
	typedef TIdMWayTreeNode inherited;
	
private:
	AnsiString FCLabel;
	Iddnscommon::TIdTextModeRRs* FRRs;
	Classes::TStrings* FChildIndex;
	TIdDNTreeNode* FParentNode;
	bool FAutoSortChild;
	void __fastcall SetCLabel(const AnsiString Value);
	void __fastcall SetRRs(const Iddnscommon::TIdTextModeRRs* Value);
	TIdDNTreeNode* __fastcall GetNode(int Index);
	void __fastcall SetNode(int Index, const TIdDNTreeNode* Value);
	void __fastcall SetChildIndex(const Classes::TStrings* Value);
	AnsiString __fastcall GetFullName();
	AnsiString __fastcall ConvertToDNString();
	Idglobal::TBytes __fastcall DumpAllBinaryData(int &RecordCount);
	
public:
	__property TIdDNTreeNode* ParentNode = {read=FParentNode, write=FParentNode};
	__property AnsiString CLabel = {read=FCLabel, write=SetCLabel};
	__property Iddnscommon::TIdTextModeRRs* RRs = {read=FRRs, write=SetRRs};
	__property TIdDNTreeNode* Children[int Index] = {read=GetNode, write=SetNode};
	__property Classes::TStrings* ChildIndex = {read=FChildIndex, write=SetChildIndex};
	__property bool AutoSortChild = {read=FAutoSortChild, write=FAutoSortChild, nodefault};
	__property AnsiString FullName = {read=GetFullName};
	__fastcall TIdDNTreeNode(TIdDNTreeNode* ParentNode);
	__fastcall virtual ~TIdDNTreeNode(void);
	HIDESBASE TIdDNTreeNode* __fastcall AddChild(void);
	HIDESBASE TIdDNTreeNode* __fastcall InsertChild(int Index);
	HIDESBASE void __fastcall RemoveChild(int Index);
	void __fastcall SortChildren(void);
	void __fastcall Clear(void);
	void __fastcall SaveToFile(AnsiString Filename);
	int __fastcall IndexByLabel(AnsiString CLabel);
	int __fastcall IndexByNode(TIdDNTreeNode* ANode);
};


typedef void __fastcall (__closure *TIdDNSAfterQueryEvent)(Idsockethandle::TIdSocketHandle* ABinding, Iddnscommon::TDNSHeader* ADNSHeader, AnsiString &QueryResult, AnsiString ResultCode, AnsiString Query);

typedef void __fastcall (__closure *TIdDNSBeforeQueryEvent)(Idsockethandle::TIdSocketHandle* ABinding, Iddnscommon::TDNSHeader* ADNSHeader, AnsiString &ADNSQuery);

typedef void __fastcall (__closure *TIdDNSAfterCacheSaved)(TIdDNTreeNode* CacheRoot);

class PASCALIMPLEMENTATION TIdDNS_UDPServer : public Idudpserver::TIdUDPServer 
{
	typedef Idudpserver::TIdUDPServer inherited;
	
private:
	bool FBusy;
	
protected:
	bool FAutoUpdateZoneInfo;
	Classes::TStrings* FZoneMasterFiles;
	Classes::TStrings* FRootDNS_NET;
	bool FCacheUnknowZone;
	TIdDNTreeNode* FCached_Tree;
	TIdDNTreeNode* FHanded_Tree;
	Classes::TStrings* FHanded_DomainList;
	bool FAutoLoadMasterFile;
	TIdDNSAfterQueryEvent FOnAfterQuery;
	TIdDNSBeforeQueryEvent FOnBeforeQuery;
	Idglobal::TIdCriticalSection* FCS;
	TIdDNSAfterQueryEvent FOnAfterSendBack;
	TIdDNSAfterCacheSaved FOnAfterCacheSaved;
	Idglobal::TIdCriticalSection* FGlobalCS;
	AnsiString FDNSVersion;
	bool FofferDNSVersion;
	DYNAMIC void __fastcall DoBeforeQuery(Idsockethandle::TIdSocketHandle* ABinding, Iddnscommon::TDNSHeader* ADNSHeader, AnsiString &ADNSQuery);
	DYNAMIC void __fastcall DoAfterQuery(Idsockethandle::TIdSocketHandle* ABinding, Iddnscommon::TDNSHeader* ADNSHeader, AnsiString &QueryResult, AnsiString ResultCode, AnsiString Query);
	DYNAMIC void __fastcall DoAfterSendBack(Idsockethandle::TIdSocketHandle* ABinding, Iddnscommon::TDNSHeader* ADNSHeader, AnsiString &QueryResult, AnsiString ResultCode, AnsiString Query);
	DYNAMIC void __fastcall DoAfterCacheSaved(TIdDNTreeNode* CacheRoot);
	void __fastcall SetZoneMasterFiles(const Classes::TStrings* Value);
	void __fastcall SetRootDNS_NET(const Classes::TStrings* Value);
	void __fastcall SetHanded_DomainList(const Classes::TStrings* Value);
	void __fastcall InternalSearch(Iddnscommon::TDNSHeader* Header, AnsiString QName, Word QType, Idglobal::TBytes &Answer, bool IfMainQuestion, bool IsSearchCache = false, bool IsAdditional = false, bool IsWildCard = false, AnsiString WildCardOrgName = "");
	void __fastcall ExternalSearch(Iddnsresolver::TIdDNSResolver* aDNSResolver, Iddnscommon::TDNSHeader* Header, Idglobal::TBytes Question, Idglobal::TBytes &Answer);
	void __fastcall SaveToCache(AnsiString ResourceRecord, AnsiString QueryName, Word OriginalQType);
	virtual void __fastcall InitComponent(void);
	__property bool AutoUpdateZoneInfo = {read=FAutoUpdateZoneInfo, write=FAutoUpdateZoneInfo, nodefault};
	__property Idglobal::TIdCriticalSection* CS = {read=FCS};
	virtual void __fastcall DoUDPRead(Idglobal::TBytes AData, Idsockethandle::TIdSocketHandle* ABinding);
	
public:
	__fastcall virtual ~TIdDNS_UDPServer(void);
	AnsiString __fastcall AXFR(Iddnscommon::TDNSHeader* Header, AnsiString Question, Idglobal::TBytes &Answer);
	AnsiString __fastcall CompleteQuery(Iddnscommon::TDNSHeader* DNSHeader, AnsiString Question, Idglobal::TBytes OriginalQuestion, Idglobal::TBytes &Answer, Word QType, Word QClass, Iddnsresolver::TIdDNSResolver* DNSResolver);
	bool __fastcall LoadZoneFromMasterFile(AnsiString MasterFileName);
	bool __fastcall LoadZoneStrings(Classes::TStrings* FileStrings, AnsiString Filename, TIdDNTreeNode* TreeRoot);
	TIdDNTreeNode* __fastcall SearchTree(TIdDNTreeNode* Root, AnsiString QName, Word QType);
	void __fastcall UpdateTree(TIdDNTreeNode* TreeRoot, Iddnscommon::TIdTextModeResourceRecord* RR)/* overload */;
	AnsiString __fastcall FindNodeFullName(TIdDNTreeNode* Root, AnsiString QName, Word QType);
	TIdDNTreeNode* __fastcall FindHandedNodeByName(AnsiString QName, Word QType);
	void __fastcall UpdateTree(TIdDNTreeNode* TreeRoot, Iddnsresolver::TResultRecord* RR)/* overload */;
	__property Classes::TStrings* RootDNS_NET = {read=FRootDNS_NET, write=SetRootDNS_NET};
	__property TIdDNTreeNode* Cached_Tree = {read=FCached_Tree};
	__property TIdDNTreeNode* Handed_Tree = {read=FHanded_Tree};
	__property bool Busy = {read=FBusy, nodefault};
	__property Idglobal::TIdCriticalSection* GlobalCS = {read=FGlobalCS};
	
__published:
	__property DefaultPort  = {default=53};
	__property bool AutoLoadMasterFile = {read=FAutoLoadMasterFile, write=FAutoLoadMasterFile, default=0};
	__property Classes::TStrings* ZoneMasterFiles = {read=FZoneMasterFiles, write=SetZoneMasterFiles};
	__property bool CacheUnknowZone = {read=FCacheUnknowZone, write=FCacheUnknowZone, default=0};
	__property Classes::TStrings* Handed_DomainList = {read=FHanded_DomainList, write=SetHanded_DomainList};
	__property AnsiString DNSVersion = {read=FDNSVersion, write=FDNSVersion};
	__property bool offerDNSVersion = {read=FofferDNSVersion, write=FofferDNSVersion, nodefault};
	__property TIdDNSBeforeQueryEvent OnBeforeQuery = {read=FOnBeforeQuery, write=FOnBeforeQuery};
	__property TIdDNSAfterQueryEvent OnAfterQuery = {read=FOnAfterQuery, write=FOnAfterQuery};
	__property TIdDNSAfterQueryEvent OnAfterSendBack = {read=FOnAfterSendBack, write=FOnAfterSendBack};
	__property TIdDNSAfterCacheSaved OnAfterCacheSaved = {read=FOnAfterCacheSaved, write=FOnAfterCacheSaved};
public:
	#pragma option push -w-inl
	/* TIdBaseComponent.Create */ inline __fastcall TIdDNS_UDPServer(Classes::TComponent* AOwner)/* overload */ : Idudpserver::TIdUDPServer(AOwner) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TIdDNSMap : public Idcontainers::TIdObjectList 
{
	typedef Idcontainers::TIdObjectList inherited;
	
public:
	TIdDomainNameServerMapping* operator[](int Index) { return Items[Index]; }
	
private:
	TIdDNS_UDPServer* FServer;
	HIDESBASE TIdDomainNameServerMapping* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TIdDomainNameServerMapping* Value);
	void __fastcall SetServer(const TIdDNS_UDPServer* Value);
	
public:
	__fastcall TIdDNSMap(TIdDNS_UDPServer* Server);
	__fastcall virtual ~TIdDNSMap(void);
	__property TIdDNS_UDPServer* Server = {read=FServer, write=SetServer};
	__property TIdDomainNameServerMapping* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
};


class PASCALIMPLEMENTATION TIdDomainNameServerMapping : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FHost;
	AnsiString FDomainName;
	bool FBusy;
	unsigned FInterval;
	TIdDNSMap* FList;
	void __fastcall SetHost(const AnsiString Value);
	void __fastcall SetInterval(const unsigned Value);
	
protected:
	TIdDomainExpireCheckThread* CheckScheduler;
	__property unsigned Interval = {read=FInterval, write=SetInterval, nodefault};
	__property TIdDNSMap* List = {read=FList, write=FList};
	
public:
	__fastcall TIdDomainNameServerMapping(TIdDNSMap* List);
	__fastcall virtual ~TIdDomainNameServerMapping(void);
	
__published:
	void __fastcall SyncAndUpdate(System::TObject* Sender);
	__property AnsiString Host = {read=FHost, write=SetHost};
	__property AnsiString DomainName = {read=FDomainName, write=FDomainName};
};


class DELPHICLASS TIdDNS_TCPServer;
class PASCALIMPLEMENTATION TIdDNS_TCPServer : public Idcustomtcpserver::TIdCustomTCPServer 
{
	typedef Idcustomtcpserver::TIdCustomTCPServer inherited;
	
protected:
	Classes::TStrings* FAccessList;
	bool FAccessControl;
	virtual void __fastcall DoConnect(Idcontext::TIdContext* AThread);
	virtual void __fastcall InitComponent(void);
	void __fastcall SetAccessList(const Classes::TStrings* Value);
	
public:
	__fastcall virtual ~TIdDNS_TCPServer(void);
	
__published:
	__property Classes::TStrings* AccessList = {read=FAccessList, write=SetAccessList};
	__property bool AccessControl = {read=FAccessControl, write=FAccessControl, nodefault};
public:
	#pragma option push -w-inl
	/* TIdBaseComponent.Create */ inline __fastcall TIdDNS_TCPServer(Classes::TComponent* AOwner)/* overload */ : Idcustomtcpserver::TIdCustomTCPServer(AOwner) { }
	#pragma option pop
	
};


class DELPHICLASS TIdDNS_ProcessThread;
class PASCALIMPLEMENTATION TIdDNS_ProcessThread : public Idthread::TIdThread 
{
	typedef Idthread::TIdThread inherited;
	
protected:
	Idsockethandle::TIdSocketHandle* FMyBinding;
	Idsockethandle::TIdSocketHandle* FMainBinding;
	Classes::TStream* FMyData;
	AnsiString FData;
	int FDataSize;
	TIdDNS_UDPServer* FServer;
	void __fastcall SetMyBinding(const Idsockethandle::TIdSocketHandle* Value);
	void __fastcall SetMyData(const Classes::TStream* Value);
	void __fastcall SetServer(const TIdDNS_UDPServer* Value);
	void __fastcall ComposeErrorResult(Idglobal::TBytes &Final, Iddnscommon::TDNSHeader* OriginalHeader, Idglobal::TBytes OriginalQuestion, int ErrorStatus);
	Idglobal::TBytes __fastcall CombineAnswer(Iddnscommon::TDNSHeader* Header, Idglobal::TBytes EQuery, Idglobal::TBytes Answer);
	void __fastcall InternalSearch(Iddnscommon::TDNSHeader* Header, AnsiString QName, Word QType, Idglobal::TBytes &Answer, bool IfMainQuestion, bool IsSearchCache = false, bool IsAdditional = false, bool IsWildCard = false, AnsiString WildCardOrgName = "");
	void __fastcall ExternalSearch(Iddnsresolver::TIdDNSResolver* aDNSResolver, Iddnscommon::TDNSHeader* Header, Idglobal::TBytes Question, Idglobal::TBytes &Answer);
	AnsiString __fastcall CompleteQuery(Iddnscommon::TDNSHeader* DNSHeader, AnsiString Question, Idglobal::TBytes OriginalQuestion, Idglobal::TBytes &Answer, Word QType, Word QClass, Iddnsresolver::TIdDNSResolver* DNSResolver);
	void __fastcall SaveToCache(AnsiString ResourceRecord, AnsiString QueryName, Word OriginalQType);
	TIdDNTreeNode* __fastcall SearchTree(TIdDNTreeNode* Root, AnsiString QName, Word QType);
	virtual void __fastcall Run(void);
	void __fastcall QueryDomain(void);
	void __fastcall SendData(void);
	
public:
	__property Idsockethandle::TIdSocketHandle* MyBinding = {read=FMyBinding, write=SetMyBinding};
	__property Classes::TStream* MyData = {read=FMyData, write=SetMyData};
	__property TIdDNS_UDPServer* Server = {read=FServer, write=SetServer};
	__fastcall TIdDNS_ProcessThread(bool ACreateSuspended, AnsiString Data, int DataSize, Idsockethandle::TIdSocketHandle* MainBinding, Idsockethandle::TIdSocketHandle* Binding, TIdDNS_UDPServer* Server)/* overload */;
	__fastcall virtual ~TIdDNS_ProcessThread(void);
};


class DELPHICLASS TIdDNSServer;
class PASCALIMPLEMENTATION TIdDNSServer : public Idcomponent::TIdComponent 
{
	typedef Idcomponent::TIdComponent inherited;
	
protected:
	bool FActive;
	bool FTCPACLActive;
	Iddnscommon::TDNSServerTypes FServerType;
	TIdDNS_TCPServer* FTCPTunnel;
	TIdDNS_UDPServer* FUDPTunnel;
	Classes::TStrings* FAccessList;
	Idsockethandle::TIdSocketHandles* FBindings;
	void __fastcall SetAccessList(const Classes::TStrings* Value);
	void __fastcall SetActive(const bool Value);
	void __fastcall SetTCPACLActive(const bool Value);
	void __fastcall SetBindings(const Idsockethandle::TIdSocketHandles* Value);
	void __fastcall TimeToUpdateNodeData(System::TObject* Sender);
	virtual void __fastcall InitComponent(void);
	
public:
	TIdDNSMap* BackupDNSMap;
	__fastcall virtual ~TIdDNSServer(void);
	void __fastcall CheckIfExpire(System::TObject* Sender);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, nodefault};
	__property Classes::TStrings* AccessList = {read=FAccessList, write=SetAccessList};
	__property Idsockethandle::TIdSocketHandles* Bindings = {read=FBindings, write=SetBindings};
	__property bool TCPACLActive = {read=FTCPACLActive, write=SetTCPACLActive, nodefault};
	__property Iddnscommon::TDNSServerTypes ServerType = {read=FServerType, write=FServerType, nodefault};
	__property TIdDNS_TCPServer* TCPTunnel = {read=FTCPTunnel, write=FTCPTunnel};
	__property TIdDNS_UDPServer* UDPTunnel = {read=FUDPTunnel, write=FUDPTunnel};
public:
	#pragma option push -w-inl
	/* TIdBaseComponent.Create */ inline __fastcall TIdDNSServer(Classes::TComponent* AOwner)/* overload */ : Idcomponent::TIdComponent(AOwner) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE int __fastcall CompareItems(System::TObject* Item1, System::TObject* Item2);
extern PACKAGE bool __fastcall SameArray(const Idglobal::TBytes B1, const Idglobal::TBytes B2);
extern PACKAGE int __fastcall PosBytes(const Idglobal::TBytes SubBytes, const Idglobal::TBytes SBytes);
extern PACKAGE Idglobal::TBytes __fastcall FetchBytes(Idglobal::TBytes &AInput, const Idglobal::TBytes ADelim, const bool ADelete = true);

}	/* namespace Iddnsserver */
using namespace Iddnsserver;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IdDNSServer
