// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IdPOP3.pas' rev: 6.00

#ifndef IdPOP3HPP
#define IdPOP3HPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <IdComponent.hpp>	// Pascal unit
#include <IdTCPConnection.hpp>	// Pascal unit
#include <IdTCPClient.hpp>	// Pascal unit
#include <IdUserPassProvider.hpp>	// Pascal unit
#include <IdBaseComponent.hpp>	// Pascal unit
#include <IdObjs.hpp>	// Pascal unit
#include <IdSys.hpp>	// Pascal unit
#include <IdSASLCollection.hpp>	// Pascal unit
#include <IdSASL.hpp>	// Pascal unit
#include <IdReply.hpp>	// Pascal unit
#include <IdMessageClient.hpp>	// Pascal unit
#include <IdMessage.hpp>	// Pascal unit
#include <IdGlobalProtocols.hpp>	// Pascal unit
#include <IdExplicitTLSClientServerBase.hpp>	// Pascal unit
#include <IdException.hpp>	// Pascal unit
#include <IdGlobal.hpp>	// Pascal unit
#include <IdAssignedNumbers.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Idpop3
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIdPOP3AuthenticationType { atUserPass, atAPOP, atSASL };
#pragma option pop

class DELPHICLASS TIdPOP3;
class PASCALIMPLEMENTATION TIdPOP3 : public Idmessageclient::TIdMessageClient 
{
	typedef Idmessageclient::TIdMessageClient inherited;
	
protected:
	TIdPOP3AuthenticationType FAuthType;
	bool FAutoLogin;
	AnsiString FAPOPToken;
	bool FHasAPOP;
	bool FHasCAPA;
	Idsaslcollection::TIdSASLEntries* FSASLMechanisms;
	virtual TMetaClass* __fastcall GetReplyClass(void);
	virtual bool __fastcall GetSupportsTLS(void);
	void __fastcall SetSASLMechanisms(Idsaslcollection::TIdSASLEntries* AValue);
	virtual void __fastcall InitComponent(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	int __fastcall CheckMessages(void);
	virtual void __fastcall Connect(void)/* overload */;
	virtual void __fastcall Login(void);
	__fastcall virtual ~TIdPOP3(void);
	bool __fastcall Delete(const int MsgNum);
	virtual void __fastcall DisconnectNotifyPeer(void);
	void __fastcall KeepAlive(void);
	bool __fastcall Reset(void);
	bool __fastcall Retrieve(const int MsgNum, Idmessage::TIdMessage* AMsg);
	bool __fastcall RetrieveHeader(const int MsgNum, Idmessage::TIdMessage* AMsg);
	int __fastcall RetrieveMsgSize(const int MsgNum);
	int __fastcall RetrieveMailBoxSize(void);
	bool __fastcall RetrieveRaw(const int aMsgNo, const Classes::TStrings* aDest)/* overload */;
	bool __fastcall RetrieveRaw(const int aMsgNo, const Classes::TStream* aDest)/* overload */;
	bool __fastcall UIDL(const Classes::TStrings* ADest, const int AMsgNum = 0xffffffff);
	bool __fastcall Top(const int AMsgNum, const Classes::TStrings* ADest, const int AMaxLines = 0x0);
	bool __fastcall CAPA(void);
	__property bool HasAPOP = {read=FHasAPOP, nodefault};
	__property bool HasCAPA = {read=FHasCAPA, nodefault};
	
__published:
	__property TIdPOP3AuthenticationType AuthType = {read=FAuthType, write=FAuthType, default=0};
	__property bool AutoLogin = {read=FAutoLogin, write=FAutoLogin, nodefault};
	__property Host ;
	__property Username ;
	__property UseTLS  = {default=0};
	__property Password ;
	__property Port  = {default=110};
	__property Idsaslcollection::TIdSASLEntries* SASLMechanisms = {read=FSASLMechanisms, write=SetSASLMechanisms};
public:
	#pragma option push -w-inl
	/* TIdBaseComponent.Create */ inline __fastcall TIdPOP3(Classes::TComponent* AOwner)/* overload */ : Idmessageclient::TIdMessageClient(AOwner) { }
	#pragma option pop
	
	
/* Hoisted overloads: */
	
public:
	inline void __fastcall  Connect(const AnsiString AHost){ TIdTCPClientCustom::Connect(AHost); }
	inline void __fastcall  Connect(const AnsiString AHost, const int APort){ TIdTCPClientCustom::Connect(AHost, APort); }
	
};


class DELPHICLASS EIdPOP3Exception;
class PASCALIMPLEMENTATION EIdPOP3Exception : public Idexception::EIdException 
{
	typedef Idexception::EIdException inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdPOP3Exception(AnsiString AMsg)/* overload */ : Idexception::EIdException(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdPOP3Exception(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Idexception::EIdException(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdPOP3Exception(int Ident)/* overload */ : Idexception::EIdException(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdPOP3Exception(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Idexception::EIdException(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdPOP3Exception(const AnsiString Msg, int AHelpContext) : Idexception::EIdException(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdPOP3Exception(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Idexception::EIdException(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdPOP3Exception(int Ident, int AHelpContext)/* overload */ : Idexception::EIdException(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdPOP3Exception(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Idexception::EIdException(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdPOP3Exception(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdDoesNotSupportAPOP;
class PASCALIMPLEMENTATION EIdDoesNotSupportAPOP : public EIdPOP3Exception 
{
	typedef EIdPOP3Exception inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdDoesNotSupportAPOP(AnsiString AMsg)/* overload */ : EIdPOP3Exception(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdDoesNotSupportAPOP(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : EIdPOP3Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdDoesNotSupportAPOP(int Ident)/* overload */ : EIdPOP3Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdDoesNotSupportAPOP(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : EIdPOP3Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdDoesNotSupportAPOP(const AnsiString Msg, int AHelpContext) : EIdPOP3Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdDoesNotSupportAPOP(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : EIdPOP3Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdDoesNotSupportAPOP(int Ident, int AHelpContext)/* overload */ : EIdPOP3Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdDoesNotSupportAPOP(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : EIdPOP3Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdDoesNotSupportAPOP(void) { }
	#pragma option pop
	
};


class DELPHICLASS EIdUnrecognizedReply;
class PASCALIMPLEMENTATION EIdUnrecognizedReply : public EIdPOP3Exception 
{
	typedef EIdPOP3Exception inherited;
	
public:
	#pragma option push -w-inl
	/* EIdException.Create */ inline __fastcall virtual EIdUnrecognizedReply(AnsiString AMsg)/* overload */ : EIdPOP3Exception(AMsg) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EIdUnrecognizedReply(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : EIdPOP3Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EIdUnrecognizedReply(int Ident)/* overload */ : EIdPOP3Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EIdUnrecognizedReply(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : EIdPOP3Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EIdUnrecognizedReply(const AnsiString Msg, int AHelpContext) : EIdPOP3Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EIdUnrecognizedReply(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : EIdPOP3Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EIdUnrecognizedReply(int Ident, int AHelpContext)/* overload */ : EIdPOP3Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EIdUnrecognizedReply(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : EIdPOP3Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EIdUnrecognizedReply(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const bool DEF_POP3USE_IMPLICIT_TLS = false;
#define DEF_ATYPE (TIdPOP3AuthenticationType)(0)

}	/* namespace Idpop3 */
using namespace Idpop3;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IdPOP3
